package Store;

//@author ShabanaY
import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;

public class StoreFrame extends javax.swing.JFrame 
{
  public ArrayList<Customer> customerList = new ArrayList<>();
  protected Customer newCustomer = new Customer(0, "", "", "", "");
  
  public ArrayList<Product> productList = new ArrayList<>();
  protected Product newProduct = new Product("", 0.0, "");
    
  // Creates new form StoreFrame
  public StoreFrame() 
  {
    initComponents();
  }

  /**
   * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    mainPanel = new javax.swing.JPanel();
    mainTabbedPane = new javax.swing.JTabbedPane();
    pnlCustomer = new javax.swing.JPanel();
    scrlCustomer = new javax.swing.JScrollPane();
    tblCustomer = new javax.swing.JTable();
    btnAddCustomer = new javax.swing.JButton();
    btnUpdateCustomer = new javax.swing.JButton();
    BtnDeleteCustomer = new javax.swing.JButton();
    lblFirstName = new javax.swing.JLabel();
    lblLastName = new javax.swing.JLabel();
    lblAddress = new javax.swing.JLabel();
    lblID = new javax.swing.JLabel();
    lblVIP = new javax.swing.JLabel();
    cbVIP = new javax.swing.JComboBox<>();
    tfID = new javax.swing.JTextField();
    tfFirstName = new javax.swing.JTextField();
    tfLastName = new javax.swing.JTextField();
    tfAddress = new javax.swing.JTextField();
    BtnSaveCustomer = new javax.swing.JButton();
    pnlProduct = new javax.swing.JPanel();
    lblInStock = new javax.swing.JLabel();
    lblProductPrice = new javax.swing.JLabel();
    lblProductName = new javax.swing.JLabel();
    BtnUpdateProduct = new javax.swing.JButton();
    BtnAddProduct = new javax.swing.JButton();
    BtnDeleteProduct = new javax.swing.JButton();
    sclProduct = new javax.swing.JScrollPane();
    tblProduct = new javax.swing.JTable();
    cbInStock = new javax.swing.JComboBox<>();
    tfProductPrice = new javax.swing.JTextField();
    tfProductName = new javax.swing.JTextField();
    BtnSaveProduct = new javax.swing.JButton();
    msg = new javax.swing.JTextField();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setTitle("Electronics Store");

    mainPanel.setPreferredSize(new java.awt.Dimension(780, 600));

    tblCustomer.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "ID", "First Name", "Last Name", "Address", "VIP Status"
      }
    ) {
      Class[] types = new Class [] {
        java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
      };

      public Class getColumnClass(int columnIndex) {
        return types [columnIndex];
      }
    });
    tblCustomer.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        tblCustomerMouseClicked(evt);
      }
    });
    scrlCustomer.setViewportView(tblCustomer);

    btnAddCustomer.setText("Add");
    btnAddCustomer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnAddCustomerActionPerformed(evt);
      }
    });

    btnUpdateCustomer.setText("Update");
    btnUpdateCustomer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnUpdateCustomerActionPerformed(evt);
      }
    });

    BtnDeleteCustomer.setText("Delete");
    BtnDeleteCustomer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        BtnDeleteCustomerActionPerformed(evt);
      }
    });

    lblFirstName.setText("First Name");

    lblLastName.setText("Last Name");

    lblAddress.setText("Address");

    lblID.setText("ID");

    lblVIP.setText("VIP");

    cbVIP.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "No", "Yes" }));

    BtnSaveCustomer.setText("Save");
    BtnSaveCustomer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        BtnSaveCustomerActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout pnlCustomerLayout = new javax.swing.GroupLayout(pnlCustomer);
    pnlCustomer.setLayout(pnlCustomerLayout);
    pnlCustomerLayout.setHorizontalGroup(
      pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(scrlCustomer, javax.swing.GroupLayout.DEFAULT_SIZE, 845, Short.MAX_VALUE)
      .addGroup(pnlCustomerLayout.createSequentialGroup()
        .addContainerGap()
        .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(lblID, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(lblVIP, javax.swing.GroupLayout.DEFAULT_SIZE, 34, Short.MAX_VALUE))
        .addGap(18, 18, 18)
        .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(tfID)
          .addComponent(cbVIP, 0, 60, Short.MAX_VALUE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addGroup(pnlCustomerLayout.createSequentialGroup()
            .addComponent(lblAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(tfAddress))
          .addGroup(pnlCustomerLayout.createSequentialGroup()
            .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
              .addComponent(lblLastName, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
              .addComponent(lblFirstName, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGap(18, 18, 18)
            .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
              .addComponent(tfFirstName)
              .addComponent(tfLastName, javax.swing.GroupLayout.PREFERRED_SIZE, 177, javax.swing.GroupLayout.PREFERRED_SIZE))))
        .addGap(65, 65, 65)
        .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
          .addComponent(BtnSaveCustomer, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(BtnDeleteCustomer, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(btnUpdateCustomer, javax.swing.GroupLayout.DEFAULT_SIZE, 115, Short.MAX_VALUE)
          .addComponent(btnAddCustomer, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addGap(44, 44, 44))
    );
    pnlCustomerLayout.setVerticalGroup(
      pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(pnlCustomerLayout.createSequentialGroup()
        .addComponent(scrlCustomer, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(pnlCustomerLayout.createSequentialGroup()
            .addGap(0, 0, Short.MAX_VALUE)
            .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
              .addComponent(lblID)
              .addComponent(tfID, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
              .addComponent(lblVIP)
              .addComponent(cbVIP, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGap(64, 64, 64))
          .addGroup(pnlCustomerLayout.createSequentialGroup()
            .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addGroup(pnlCustomerLayout.createSequentialGroup()
                .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                  .addComponent(lblFirstName, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                  .addComponent(tfFirstName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                  .addComponent(lblLastName, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                  .addComponent(tfLastName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(pnlCustomerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                  .addComponent(tfAddress, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                  .addComponent(lblAddress, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)))
              .addGroup(pnlCustomerLayout.createSequentialGroup()
                .addComponent(btnAddCustomer)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnUpdateCustomer)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BtnDeleteCustomer)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BtnSaveCustomer)))
            .addContainerGap(32, Short.MAX_VALUE))))
    );

    mainTabbedPane.addTab("Customer", pnlCustomer);

    lblInStock.setText("In Stock");

    lblProductPrice.setText("Product Price");

    lblProductName.setText("Product Name");

    BtnUpdateProduct.setText("Update");
    BtnUpdateProduct.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        BtnUpdateProductActionPerformed(evt);
      }
    });

    BtnAddProduct.setText("Add");
    BtnAddProduct.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        BtnAddProductActionPerformed(evt);
      }
    });

    BtnDeleteProduct.setText("Delete");
    BtnDeleteProduct.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        BtnDeleteProductActionPerformed(evt);
      }
    });

    tblProduct.setModel(new javax.swing.table.DefaultTableModel(
      new Object [][] {

      },
      new String [] {
        "Product Name", "Product Price", "In Stock Status"
      }
    ));
    tblProduct.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        tblProductMouseClicked(evt);
      }
    });
    sclProduct.setViewportView(tblProduct);

    cbInStock.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Yes", "No" }));

    BtnSaveProduct.setText("Save");
    BtnSaveProduct.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        BtnSaveProductActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout pnlProductLayout = new javax.swing.GroupLayout(pnlProduct);
    pnlProduct.setLayout(pnlProductLayout);
    pnlProductLayout.setHorizontalGroup(
      pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlProductLayout.createSequentialGroup()
        .addContainerGap()
        .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
            .addComponent(lblProductPrice, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(lblProductName, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE))
          .addComponent(lblInStock, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(40, 40, 40)
        .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(cbInStock, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(tfProductPrice)
          .addComponent(tfProductName, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 117, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(366, 366, 366)
        .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
            .addComponent(BtnUpdateProduct, javax.swing.GroupLayout.DEFAULT_SIZE, 115, Short.MAX_VALUE)
            .addComponent(BtnDeleteProduct, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(BtnAddProduct, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
          .addComponent(BtnSaveProduct, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(42, 42, 42))
      .addComponent(sclProduct)
    );
    pnlProductLayout.setVerticalGroup(
      pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(pnlProductLayout.createSequentialGroup()
        .addComponent(sclProduct, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(pnlProductLayout.createSequentialGroup()
            .addGap(7, 7, 7)
            .addComponent(BtnAddProduct)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(BtnUpdateProduct)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(BtnDeleteProduct)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(BtnSaveProduct))
          .addGroup(pnlProductLayout.createSequentialGroup()
            .addGap(18, 18, 18)
            .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addGroup(pnlProductLayout.createSequentialGroup()
                .addComponent(tfProductPrice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(cbInStock, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
              .addGroup(pnlProductLayout.createSequentialGroup()
                .addGroup(pnlProductLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                  .addComponent(lblProductName, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                  .addComponent(tfProductName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblProductPrice, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblInStock, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)))))
        .addContainerGap(25, Short.MAX_VALUE))
    );

    mainTabbedPane.addTab("Product", pnlProduct);

    javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
    mainPanel.setLayout(mainPanelLayout);
    mainPanelLayout.setHorizontalGroup(
      mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(mainTabbedPane)
    );
    mainPanelLayout.setVerticalGroup(
      mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(mainTabbedPane, javax.swing.GroupLayout.Alignment.TRAILING)
    );

    msg.setForeground(new java.awt.Color(255, 0, 0));

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 850, Short.MAX_VALUE)
      .addComponent(msg)
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(mainPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 550, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addComponent(msg, javax.swing.GroupLayout.DEFAULT_SIZE, 39, Short.MAX_VALUE))
    );

    pack();
  }// </editor-fold>//GEN-END:initComponents

  private void BtnSaveProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnSaveProductActionPerformed
    msg.setText("");
    DefaultTableModel model = (DefaultTableModel) tblProduct.getModel();
    if(tblProduct.getRowCount()==0)
      {
        msg.setText("Product table is empty!");
      }
      else
      {
        for (int row = 0; row < tblProduct.getRowCount(); row++)
        {
          newProduct.setProductName((String)tblProduct.getValueAt(row, 0));
          newProduct.setProductPrice(Double.parseDouble((String)tblProduct.getValueAt(row, 1)));
          newProduct.setInStock((String)tblProduct.getValueAt(row, 2));
        }
        productList.add(newProduct);
        newProduct = new Product("", 0.0, "");
	}
  }//GEN-LAST:event_BtnSaveProductActionPerformed
  
  private void tblProductMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblProductMouseClicked
    DefaultTableModel model = (DefaultTableModel) tblProduct.getModel();
    tfProductName.setText(model.getValueAt(tblProduct.getSelectedRow(), 0).toString());
    tfProductPrice.setText(model.getValueAt(tblProduct.getSelectedRow(), 1).toString());
    cbInStock.setSelectedItem(model.getValueAt(tblProduct.getSelectedRow(), 2).toString());
  }//GEN-LAST:event_tblProductMouseClicked

  private void BtnDeleteProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnDeleteProductActionPerformed
    DefaultTableModel model = (DefaultTableModel) tblProduct.getModel();
    if(tblProduct.getSelectedRow()==-1)
    {
      if(tblProduct.getRowCount()==0)
      {
        msg.setText("Product data is empty!");
      }
      else
      {
        msg.setText("You must select a product to delete!");
      }
    }
    else
    {
      model.removeRow(tblProduct.getSelectedRow());
    }
  }//GEN-LAST:event_BtnDeleteProductActionPerformed

  private void BtnAddProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnAddProductActionPerformed
    msg.setText("");
    DefaultTableModel model = (DefaultTableModel) tblProduct.getModel();
    if(!tfProductName.getText().trim().equals(""))
    {
      model.addRow(new Object [] {tfProductName.getText(), tfProductPrice.getText(), cbInStock.getSelectedItem()});
    }
    else
    {
      msg.setText("Product name should not be left blank!");
    }

    tfProductName.setText("");
    tfProductPrice.setText("");
    cbInStock.setSelectedItem("");
  }//GEN-LAST:event_BtnAddProductActionPerformed

  private void BtnUpdateProductActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnUpdateProductActionPerformed
    msg.setText("");
    DefaultTableModel model = (DefaultTableModel) tblProduct.getModel();
    if(tblProduct.getSelectedRow()==-1)
    {
      msg.setText("You must select a product to edit!");
    }
    else
    {
      model.setValueAt(tfProductName.getText(), tblProduct.getSelectedRow(), 0);
      model.setValueAt(tfProductPrice.getText(), tblProduct.getSelectedRow(), 1);
      model.setValueAt(cbInStock.getSelectedItem(), tblProduct.getSelectedRow(), 2);
    }

    tfProductName.setText("");
    tfProductPrice.setText("");
    cbInStock.setSelectedItem("");
  }//GEN-LAST:event_BtnUpdateProductActionPerformed

  private void BtnSaveCustomerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnSaveCustomerActionPerformed
    msg.setText("");
    DefaultTableModel model = (DefaultTableModel) tblCustomer.getModel();
    if(tblCustomer.getRowCount()==0)
      {
        msg.setText("Customer table is empty!");
      }
    else
    {
      for (int row = 0; row < tblCustomer.getRowCount(); row++)
      {
        newCustomer.setId(Integer.parseInt((String)tblCustomer.getValueAt(row, 0)));
        newCustomer.setFirstName((String)tblCustomer.getValueAt(row, 1));
        newCustomer.setLastName((String)tblCustomer.getValueAt(row, 2));
        newCustomer.setAddress((String)tblCustomer.getValueAt(row, 3));
        newCustomer.setVIP((String)tblCustomer.getValueAt(row, 4));
      }
      customerList.add(newCustomer);
      newCustomer = new Customer(0, "", "", "", "");
    }
  }//GEN-LAST:event_BtnSaveCustomerActionPerformed

  private void BtnDeleteCustomerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BtnDeleteCustomerActionPerformed
    DefaultTableModel model = (DefaultTableModel) tblCustomer.getModel();
    if(tblCustomer.getSelectedRow()==-1)
    {
      if(tblCustomer.getRowCount()==0)
      {
        msg.setText("Customer data is empty!");
      }
      else
      {
        msg.setText("You must select a customer to delete!");
      }
    }
    else
    {
      model.removeRow(tblCustomer.getSelectedRow());
    }
  }//GEN-LAST:event_BtnDeleteCustomerActionPerformed

  private void btnUpdateCustomerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnUpdateCustomerActionPerformed
    msg.setText("");
    DefaultTableModel model = (DefaultTableModel) tblCustomer.getModel();
    if(tblCustomer.getSelectedRow()==-1)
    {
      msg.setText("You must select a customer to edit!");
    }
    else
    {
      model.setValueAt(tfID.getText(), tblCustomer.getSelectedRow(), 0);
      model.setValueAt(tfFirstName.getText(), tblCustomer.getSelectedRow(), 1);
      model.setValueAt(tfLastName.getText(), tblCustomer.getSelectedRow(), 2);
      model.setValueAt(tfAddress.getText(), tblCustomer.getSelectedRow(), 3);
      model.setValueAt(cbVIP.getSelectedItem(), tblCustomer.getSelectedRow(), 4);
  }//GEN-LAST:event_btnUpdateCustomerActionPerformed
  }
  
  private void btnAddCustomerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddCustomerActionPerformed
    msg.setText("");
    DefaultTableModel model = (DefaultTableModel) tblCustomer.getModel();
    if(!tfID.getText().trim().equals(""))
    {
      model.addRow(new Object [] {tfID.getText(), tfFirstName.getText(), tfLastName.getText(), tfAddress.getText(), cbVIP.getSelectedItem()});
    }
    else
    {
      msg.setText("Customer ID should not be left blank!");
  }//GEN-LAST:event_btnAddCustomerActionPerformed
    tfID.setText("");
    tfFirstName.setText("");
    tfLastName.setText("");
    tfAddress.setText("");
    cbVIP.setSelectedItem("");
  }
  
  private void tblCustomerMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblCustomerMouseClicked
    DefaultTableModel model = (DefaultTableModel) tblCustomer.getModel();
    tfID.setText(model.getValueAt(tblCustomer.getSelectedRow(), 0).toString());
    tfFirstName.setText(model.getValueAt(tblCustomer.getSelectedRow(), 1).toString());
    tfLastName.setText(model.getValueAt(tblCustomer.getSelectedRow(), 2).toString());
    tfAddress.setText(model.getValueAt(tblCustomer.getSelectedRow(), 3).toString());
    cbVIP.setSelectedItem(model.getValueAt(tblCustomer.getSelectedRow(), 4).toString());
  }//GEN-LAST:event_tblCustomerMouseClicked
      
  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    /* Set the Nimbus look and feel */
    //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
    /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
     */
    try {
      for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
        if ("Nimbus".equals(info.getName())) {
          javax.swing.UIManager.setLookAndFeel(info.getClassName());
          break;
        }
      }
    } catch (ClassNotFoundException ex) {
      java.util.logging.Logger.getLogger(StoreFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (InstantiationException ex) {
      java.util.logging.Logger.getLogger(StoreFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (IllegalAccessException ex) {
      java.util.logging.Logger.getLogger(StoreFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } catch (javax.swing.UnsupportedLookAndFeelException ex) {
      java.util.logging.Logger.getLogger(StoreFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    }
    //</editor-fold>

    /* Create and display the form */
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new StoreFrame().setVisible(true);
      }
    });
}

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton BtnAddProduct;
  private javax.swing.JButton BtnDeleteCustomer;
  private javax.swing.JButton BtnDeleteProduct;
  private javax.swing.JButton BtnSaveCustomer;
  private javax.swing.JButton BtnSaveProduct;
  private javax.swing.JButton BtnUpdateProduct;
  private javax.swing.JButton btnAddCustomer;
  private javax.swing.JButton btnUpdateCustomer;
  private javax.swing.JComboBox<String> cbInStock;
  private javax.swing.JComboBox<String> cbVIP;
  private javax.swing.JLabel lblAddress;
  private javax.swing.JLabel lblFirstName;
  private javax.swing.JLabel lblID;
  private javax.swing.JLabel lblInStock;
  private javax.swing.JLabel lblLastName;
  private javax.swing.JLabel lblProductName;
  private javax.swing.JLabel lblProductPrice;
  private javax.swing.JLabel lblVIP;
  private javax.swing.JPanel mainPanel;
  private javax.swing.JTabbedPane mainTabbedPane;
  private javax.swing.JTextField msg;
  private javax.swing.JPanel pnlCustomer;
  private javax.swing.JPanel pnlProduct;
  private javax.swing.JScrollPane sclProduct;
  private javax.swing.JScrollPane scrlCustomer;
  private javax.swing.JTable tblCustomer;
  private javax.swing.JTable tblProduct;
  private javax.swing.JTextField tfAddress;
  private javax.swing.JTextField tfFirstName;
  private javax.swing.JTextField tfID;
  private javax.swing.JTextField tfLastName;
  private javax.swing.JTextField tfProductName;
  private javax.swing.JTextField tfProductPrice;
  // End of variables declaration//GEN-END:variables
}